import { ref as r, computed as c, onMounted as _e, onBeforeUnmount as Ne, openBlock as n, createElementBlock as m, normalizeClass as V, normalizeStyle as _, createVNode as X, createCommentVNode as N, createBlock as B, unref as h, createSlots as Pe, withCtx as p, renderSlot as g, normalizeProps as D, guardReactiveProps as W, Fragment as ue, renderList as re, createElementVNode as w, createTextVNode as ne, toDisplayString as E, nextTick as Le } from "vue";
import { u as Fe, c as ie, t as Ie, a as Se, p as T, o as Oe, e as ve, g as Me, b as ze, d as ce, f as x, X as Ae, s as Re, v as Ve, i as de, w as Be, x as De, q as We, r as Ee } from "./index-DevyUpIh.js";
import { t as Ge, u as Ue } from "./useResponsive-NZB-WLRF.js";
import { _ as He } from "./Title-Dq1rRDew.js";
import { u as Xe, U as je } from "./usePrinter-BBCKkrZI.js";
import { _ as Ye } from "./Tooltip-D-u8OLa8.js";
import { D as qe } from "./DataTable--OZ3_Ruy.js";
import { L as Je } from "./Legend-CZr69olR.js";
import Ke from "./vue-ui-skeleton-BcivVyJG.js";
import Qe from "./vue-ui-accordion-B2VGVjY5.js";
import { u as he } from "./useNestedProp-CN2WRozq.js";
import { _ as Ze } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const et = ["id"], tt = ["xmlns", "viewBox"], lt = ["id"], ot = ["stop-color"], at = ["stop-color"], st = ["stroke", "cx", "cy", "r", "fill"], ut = ["stroke", "stroke-width", "cx", "cy", "r", "fill"], rt = ["cx", "cy", "r", "onMouseenter"], nt = {
  key: 3,
  class: "vue-data-ui-watermark"
}, it = ["onClick"], vt = { key: 0 }, ct = { key: 1 }, dt = ["innerHTML"], ht = {
  __name: "vue-ui-rings",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(pe, { expose: ge, emit: fe }) {
    const f = pe, { vue_ui_rings: ye } = Fe(), P = r(!1), O = c(() => !!f.dataset && f.dataset.length), L = r(ie()), me = r(null), M = r(!1), G = r(""), $ = r(null), j = r(0), F = r(null), Y = r(null), q = r(null), e = c(() => {
      const t = he({
        userConfig: f.config,
        defaultConfig: ye
      });
      return t.theme ? {
        ...he({
          userConfig: Ie.vue_ui_rings[t.theme] || f.config,
          defaultConfig: t
        }),
        customPalette: Se[t.theme] || T
      } : t;
    }), z = r(null);
    _e(() => {
      if (Oe(f.dataset) ? ve({
        componentName: "VueUiRings",
        type: "dataset"
      }) : f.dataset.forEach((t, o) => {
        Me({
          datasetObject: t,
          requiredAttributes: ["name", "values"]
        }).forEach((l) => {
          ve({
            componentName: "VueUiRings",
            type: "datasetSerieAttribute",
            property: l,
            index: o
          });
        });
      }), e.value.responsive) {
        const t = Ge(() => {
          const { width: o, height: l } = Ue({
            chart: F.value,
            title: e.value.style.chart.title.text ? Y.value : null,
            legend: e.value.style.chart.legend.show ? q.value : null
          });
          u.value.width = o, u.value.height = l;
        });
        z.value = new ResizeObserver(t), z.value.observe(F.value.parentNode);
      }
      setTimeout(() => {
        P.value = !0;
      }, 600);
    }), Ne(() => {
      z.value && z.value.disconnect();
    });
    const { isPrinting: J, isImaging: K, generatePdf: Q, generateImage: Z } = Xe({
      elementId: `rings_${L.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-rings"
    }), ee = c(() => ze(e.value.customPalette)), k = r({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), u = r({
      height: 360,
      width: 360
    }), be = c(() => Math.min(u.value.height, u.value.width)), i = r([]);
    function U(t) {
      i.value.includes(t) ? i.value = i.value.filter((o) => o !== t) : i.value.push(t), fe("selectLegend", v.value.map((o) => ({
        name: o.name,
        color: o.color,
        value: o.value
      })));
    }
    const ke = c(() => Math.max(
      ...A.value.filter((t) => !i.value.includes(t.uid)).map(({ value: t }) => t)
    ));
    function te(t) {
      return t / ke.value;
    }
    const A = c(() => f.dataset.map(({ values: t, name: o, color: l = null }, a) => {
      const s = (t || []).reduce((b, S) => b + S, 0);
      return {
        name: o,
        color: l || ce(l) || ee.value[a] || T[a] || T[a % T.length],
        value: s,
        proportion: s / f.dataset.map((b) => (b.values || []).reduce((S, xe) => S + xe, 0)).reduce((b, S) => b + S, 0),
        uid: ie()
      };
    })), le = c(() => A.value.map((t) => ({
      ...t,
      shape: "circle",
      opacity: i.value.includes(t.uid) ? 0.5 : 1,
      segregate: () => U(t.uid),
      isSegregated: i.value.includes(t.uid)
    })).toSorted((t, o) => o.value - t.value)), Ce = c(() => ({
      cy: "rings-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), y = c(() => A.value.filter((t) => !i.value.includes(t.uid)).map(({ value: t }) => t).reduce((t, o) => t + o, 0)), v = c(() => A.value.filter((t) => !i.value.includes(t.uid)).map(({ name: t, value: o, color: l = null, uid: a }, s) => ({
      uid: a,
      name: t,
      color: l || ce(l) || ee.value[s] || T[s] || T[s % T.length],
      value: o,
      proportion: te(o),
      percentage: o / y.value * 100,
      strokeWidth: e.value.style.chart.layout.rings.strokeWidth * te(o)
    })).toSorted((t, o) => o.value - t.value));
    function we() {
      return v.value.map(
        ({ name: t, color: o, value: l, absoluteValues: a, percentage: s }) => ({
          name: t,
          color: o,
          value: l,
          absoluteValues: a,
          percentage: s
        })
      );
    }
    const d = c(() => be.value - e.value.style.chart.layout.rings.strokeWidth * 2), H = r(null);
    function $e(t, o) {
      if (i.value.length === f.dataset.length) return;
      H.value = {
        datapoint: o,
        seriesIndex: t,
        series: v.value,
        config: e.value
      }, $.value = t;
      const l = v.value[t], a = e.value.style.chart.tooltip.customFormat;
      if (Be(a) && De(() => a({
        seriesIndex: t,
        datapoint: o,
        series: v.value,
        config: e.value
      })))
        G.value = a({
          seriesIndex: t,
          datapoint: o,
          series: v.value,
          config: e.value
        });
      else {
        let s = "";
        s += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, s += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${l.color}" /></svg>`, e.value.style.chart.tooltip.showValue && (s += `<b>${de(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          l.value,
          x({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: o, seriesIndex: t }
        )}
      </b>`), e.value.style.chart.tooltip.showPercentage && (e.value.style.chart.tooltip.showValue ? s += `<span>(${x({
          v: l.value / y.value * 100,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })})</span></div>` : s += `<b>${x({
          v: l.value / y.value * 100,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })}</b></div>`), G.value = s;
      }
      M.value = !0;
    }
    const C = c(() => {
      const t = v.value.map((l) => ({
        name: l.name,
        color: l.color
      })), o = v.value.map((l) => l.value);
      return { head: t, body: o };
    }), R = c(() => {
      const t = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        x({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: y.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], o = C.value.head.map((s, b) => [
        {
          color: s.color,
          name: s.name
        },
        x({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: C.value.body[b], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        isNaN(C.value.body[b] / y.value) ? "-" : (C.value.body[b] / y.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
      ]), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, a = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ];
      return {
        head: t,
        body: o,
        config: l,
        colNames: a
      };
    });
    function oe() {
      Le(() => {
        const t = C.value.head.map((a, s) => [[
          a.name
        ], [C.value.body[s]], [isNaN(C.value.body[s] / y.value) ? "-" : C.value.body[s] / y.value * 100]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), l = We(o);
        Ee({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-rings" });
      });
    }
    const I = r(!1);
    function Te(t) {
      I.value = t, j.value += 1;
    }
    function ae() {
      k.value.showTable = !k.value.showTable;
    }
    function se() {
      k.value.showTooltip = !k.value.showTooltip;
    }
    return ge({
      getData: we,
      generatePdf: Q,
      generateCsv: oe,
      generateImage: Z,
      toggleTable: ae,
      toggleTooltip: se
    }), (t, o) => (n(), m("div", {
      ref_key: "ringsChart",
      ref: F,
      class: V(`vue-ui-rings ${I.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: _(`font-family:${e.value.style.fontFamily};text-align:center;width:100%;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`),
      id: `rings_${L.value}`,
      onMouseleave: o[3] || (o[3] = (l) => {
        $.value = null, M.value = !1;
      })
    }, [
      e.value.style.chart.title.text ? (n(), m("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: Y,
        style: _(`width:100%;background:${e.value.style.chart.backgroundColor}`)
      }, [
        X(He, {
          config: {
            title: {
              cy: "rings-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "rings-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : N("", !0),
      e.value.userOptions.show && O.value ? (n(), B(je, {
        ref_key: "details",
        ref: me,
        key: `user_options_${j.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: h(J),
        isImaging: h(K),
        uid: L.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: k.value.showTooltip,
        isFullscreen: I.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: F.value,
        onToggleFullscreen: Te,
        onGeneratePdf: h(Q),
        onGenerateCsv: oe,
        onGenerateImage: h(Z),
        onToggleTable: ae,
        onToggleTooltip: se
      }, Pe({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: p(() => [
            g(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: p(() => [
            g(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: p(() => [
            g(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: p(() => [
            g(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: p(() => [
            g(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: p(({ toggleFullscreen: l, isFullscreen: a }) => [
            g(t.$slots, "optionFullscreen", D(W({ toggleFullscreen: l, isFullscreen: a })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : N("", !0),
      O.value ? (n(), m("svg", {
        key: 2,
        xmlns: h(Ae),
        class: V({ "vue-data-ui-fullscreen--on": I.value, "vue-data-ui-fulscreen--off": !I.value }),
        viewBox: `0 0 ${u.value.width <= 0 ? 10 : u.value.width} ${u.value.height <= 0 ? 10 : u.value.height}`,
        style: _(`max-width:100%;overflow:visible;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        (n(!0), m(ue, null, re(v.value, (l, a) => (n(), m("radialGradient", {
          cx: "50%",
          cy: "30%",
          r: "50%",
          fx: "50%",
          fy: "50%",
          id: `gradient_${L.value}_${a}`
        }, [
          w("stop", {
            offset: "0%",
            "stop-color": `${h(Re)(l.color, 0.05)}${h(Ve)[100 - e.value.style.chart.layout.rings.gradient.intensity]}`
          }, null, 8, ot),
          w("stop", {
            offset: "100%",
            "stop-color": l.color
          }, null, 8, at)
        ], 8, lt))), 256)),
        (n(!0), m(ue, null, re(v.value, (l, a) => (n(), m("g", null, [
          w("circle", {
            class: V({
              "vue-ui-rings-item": P.value && e.value.useCssAnimation,
              "vue-rings-item-onload": !P.value && e.value.useCssAnimation,
              "vue-ui-rings-opacity": $.value !== null && $.value !== a
            }),
            style: _(`animation-delay:${a * 100}ms`),
            stroke: e.value.style.chart.layout.rings.stroke,
            cx: u.value.width / 2,
            cy: a === 0 ? u.value.height / 2 : u.value.height / 2 + d.value * v.value[0].proportion / 2 - d.value * l.proportion / 2 - 2 * (a + 1),
            r: d.value * l.proportion / 2 * 0.9 <= 0 ? 1e-4 : d.value * l.proportion / 2 * 0.9,
            fill: e.value.style.chart.layout.rings.gradient.underlayerColor
          }, null, 14, st),
          w("circle", {
            class: V({
              "vue-ui-rings-item": P.value && e.value.useCssAnimation,
              "vue-rings-item-onload": !P.value && e.value.useCssAnimation,
              "vue-ui-rings-shadow": e.value.style.chart.layout.rings.useShadow,
              "vue-ui-rings-blur": $.value !== null && $.value !== a
            }),
            style: _(`animation-delay:${a * 100}ms`),
            stroke: e.value.style.chart.layout.rings.stroke,
            "stroke-width": l.strokeWidth < 0.5 ? 0.5 : l.strokeWidth,
            cx: u.value.width / 2,
            cy: a === 0 ? u.value.height / 2 : u.value.height / 2 + d.value * v.value[0].proportion / 2 - d.value * l.proportion / 2 - 2 * (a + 1),
            r: d.value * l.proportion / 2 * 0.9 <= 0 ? 1e-4 : d.value * l.proportion / 2 * 0.9,
            fill: e.value.style.chart.layout.rings.gradient.show ? `url(#gradient_${L.value}_${a})` : l.color
          }, null, 14, ut),
          w("circle", {
            "data-cy-trap": "",
            stroke: "none",
            cx: u.value.width / 2,
            cy: a === 0 ? u.value.height / 2 : u.value.height / 2 + d.value * v.value[0].proportion / 2 - d.value * l.proportion / 2 - 2 * (a + 1),
            r: d.value * l.proportion / 2 * 0.9 <= 0 ? 1e-4 : d.value * l.proportion / 2 * 0.9,
            fill: "transparent",
            onMouseenter: (s) => $e(a, l),
            onMouseleave: o[0] || (o[0] = (s) => {
              $.value = null, M.value = !1;
            })
          }, null, 40, rt)
        ]))), 256)),
        g(t.$slots, "svg", { svg: u.value }, void 0, !0)
      ], 14, tt)) : N("", !0),
      t.$slots.watermark ? (n(), m("div", nt, [
        g(t.$slots, "watermark", D(W({ isPrinting: h(J) || h(K) })), void 0, !0)
      ])) : N("", !0),
      O.value ? N("", !0) : (n(), B(Ke, {
        key: 4,
        config: {
          type: "rings",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            rings: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      w("div", {
        ref_key: "chartLegend",
        ref: q
      }, [
        e.value.style.chart.legend.show ? (n(), B(Je, {
          key: 0,
          legendSet: le.value,
          config: Ce.value,
          onClickMarker: o[1] || (o[1] = ({ legend: l }) => U(l.uid))
        }, {
          item: p(({ legend: l, index: a }) => [
            w("div", {
              "data-cy-legend-item": "",
              onClick: (s) => U(l.uid),
              style: _(`opacity:${i.value.includes(l.uid) ? 0.5 : 1}`)
            }, [
              ne(E(l.name) + ": " + E(h(de)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                h(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: l, seriesIndex: a }
              )) + " ", 1),
              i.value.includes(l.uid) ? (n(), m("span", ct, " ( - % ) ")) : (n(), m("span", vt, " (" + E(isNaN(l.value / y.value) ? "-" : h(x)({
                v: l.value / y.value * 100,
                s: "%",
                r: e.value.style.chart.legend.roundingPercentage
              })) + ") ", 1))
            ], 12, it)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : g(t.$slots, "legend", {
          key: 1,
          legend: le.value
        }, void 0, !0)
      ], 512),
      X(Ye, {
        show: k.value.showTooltip && M.value && i.value.length < f.dataset.length,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: F.value,
        content: G.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": p(() => [
          g(t.$slots, "tooltip-before", D(W({ ...H.value })), void 0, !0)
        ]),
        "tooltip-after": p(() => [
          g(t.$slots, "tooltip-after", D(W({ ...H.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      O.value ? (n(), B(Qe, {
        key: 5,
        hideDetails: "",
        config: {
          open: k.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: p(() => [
          X(qe, {
            colNames: R.value.colNames,
            head: R.value.head,
            body: R.value.body,
            config: R.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[2] || (o[2] = (l) => k.value.showTable = !1)
          }, {
            th: p(({ th: l }) => [
              w("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, dt)
            ]),
            td: p(({ td: l }) => [
              ne(E(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : N("", !0)
    ], 46, et));
  }
}, _t = /* @__PURE__ */ Ze(ht, [["__scopeId", "data-v-747e43da"]]);
export {
  _t as default
};
