import { useCssVars as ne, computed as c, onMounted as ie, ref as p, openBlock as o, createElementBlock as n, normalizeClass as C, normalizeStyle as z, createVNode as he, createCommentVNode as h, createBlock as B, unref as v, createSlots as ce, withCtx as q, renderSlot as k, normalizeProps as j, guardReactiveProps as A, createElementVNode as d, Fragment as $, renderList as D, toDisplayString as de } from "vue";
import { u as ve, o as ye, e as H, g as fe, c as me, t as ge, a as pe, p as x, b as ke, d as F, X as xe, v as be, i as _e, f as we } from "./index-DevyUpIh.js";
import { _ as Ce } from "./Title-Dq1rRDew.js";
import { u as $e, U as Fe } from "./usePrinter-BBCKkrZI.js";
import Pe from "./vue-ui-skeleton-BcivVyJG.js";
import { u as X } from "./useNestedProp-CN2WRozq.js";
import { _ as Ie } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ye = ["id"], Me = {
  key: 0,
  style: "width:100%"
}, Oe = ["xmlns", "viewBox"], Ue = {
  id: "vueUiPill",
  clipPathUnits: "objectBoundingBox"
}, qe = ["fill"], Le = ["id"], Ne = ["stop-color"], Se = ["stop-color"], Te = ["stop-color"], Ge = { "clip-path": "url(#vueUiPill)" }, Ve = ["x", "y", "height", "width"], We = ["x", "y", "height", "width", "fill"], Ee = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], ze = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Be = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], je = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Ae = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], De = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], He = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Xe = ["x1", "x2", "y1", "y2", "stroke-width", "stroke"], Re = ["x", "y", "height", "width"], Je = ["y", "x", "fill", "font-size", "font-weight"], Ke = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Qe = {
  __name: "vue-ui-thermometer",
  props: {
    dataset: {
      type: Object,
      default() {
        return {};
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(b, { expose: R }) {
    const a = b;
    ne((s) => ({
      "3d1a25cf": te.value,
      "52cc1c9f": ee.value,
      "90b36568": Z.value
    }));
    const { vue_ui_thermometer: J } = ve(), P = c(() => !!a.dataset && Object.keys(a.dataset).length);
    ie(() => {
      ye(a.dataset) ? H({
        componentName: "VueUiThermometer",
        type: "dataset"
      }) : fe({
        datasetObject: a.dataset,
        requiredAttributes: ["value", "from", "to"]
      }).forEach((s) => {
        H({
          componentName: "VueUiThermometer",
          type: "datasetAttribute",
          property: s
        });
      });
    });
    const f = p(me()), L = p(null), N = p(0), e = c(() => {
      const s = X({
        userConfig: a.config,
        defaultConfig: J
      });
      return s.theme ? {
        ...X({
          userConfig: ge.vue_ui_thermometer[s.theme] || a.config,
          defaultConfig: s
        }),
        customPalette: pe[s.theme] || x
      } : s;
    }), { isPrinting: S, isImaging: T, generatePdf: G, generateImage: V } = $e({
      elementId: `thermometer__${f.value}`,
      fileName: e.value.style.title.text || "vue-ui-thermometer"
    }), _ = c(() => ke(e.value.customPalette)), K = c(() => e.value.style.chart.thermometer.width), y = c(() => a.dataset.steps || 10), i = p({
      top: e.value.style.chart.padding.top,
      left: e.value.style.chart.padding.left,
      right: e.value.style.chart.padding.right,
      bottom: e.value.style.chart.padding.bottom
    });
    function w(s, r, t) {
      const u = [], O = W(s), U = W(r);
      for (let g = 0; g < t; g++) {
        const ae = I(O.red, U.red, g, t), oe = I(O.green, U.green, g, t), re = I(O.blue, U.blue, g, t), ue = `#${Y(ae)}${Y(oe)}${Y(re)}`;
        u.push(ue);
      }
      return u;
    }
    function W(s) {
      const r = s.slice(1);
      return {
        red: parseInt(r.slice(0, 2), 16),
        green: parseInt(r.slice(2, 4), 16),
        blue: parseInt(r.slice(4, 6), 16)
      };
    }
    function I(s, r, t, u) {
      return Math.round(s + (r - s) * t / u);
    }
    function Y(s) {
      return s.toString(16).padStart(2, "0");
    }
    const l = c(() => {
      const s = K.value + i.value.left + i.value.right, r = e.value.style.chart.height;
      return {
        width: s,
        left: i.value.left,
        right: s - i.value.right,
        top: i.value.top,
        bottom: r - i.value.bottom,
        height: r
      };
    }), Q = c(() => l.value), M = c(() => {
      const s = a.dataset.from < 0 ? Math.abs(a.dataset.from) : a.dataset.from, r = a.dataset.to < 0 ? Math.abs(a.dataset.to) : a.dataset.to;
      let t = 0;
      return a.dataset.to > 0 ? t = s + r : s > r ? t = s - r : t = r - s, (1 - (Math.abs(a.dataset.from) + a.dataset.value) / t) * (l.value.height - i.value.top - i.value.bottom);
    }), Z = c(() => `${M.value}px`), ee = c(() => `${l.value.height - e.value.style.chart.padding.bottom - i.value.top}px`), te = c(() => `${e.value.style.chart.animation.speedMs}ms`), se = c(() => {
      if (a.dataset.colors) {
        if (!a.dataset.colors.from)
          return w(_.value[0] || x[0], F(a.dataset.colors.to), y.value || 10);
        if (!a.dataset.colors.to)
          return w(F(a.dataset.colors.from), _.value[1] || x[1], y.value || 10);
      } else
        return w(_.value[1] || x[1], _.value[0] || x[0], y.value || 10);
      return w(F(a.dataset.colors.from), F(a.dataset.colors.to), y.value || 10);
    }), E = c(() => {
      const s = [];
      let r = 0;
      const t = l.value.height - i.value.top - i.value.bottom;
      for (let u = 0; u < t - 1; u += t / y.value)
        s.push({
          x: l.value.left,
          y: l.value.top + u,
          qYLess: l.value.top + u + t / y.value / 4,
          halfY: l.value.top + u + t / y.value / 2,
          qYMore: l.value.top + u + t / y.value / 4 * 3,
          color: se.value[r],
          height: t / y.value
        }), r += 1;
      return s;
    }), m = p(!1);
    function le(s) {
      m.value = s, N.value += 1;
    }
    return R({
      generatePdf: G,
      generateImage: V
    }), (s, r) => (o(), n("div", {
      ref_key: "thermoChart",
      ref: L,
      class: C(`vue-ui-thermometer ${m.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: z(`width:100%;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color};font-family:${e.value.style.fontFamily}`),
      id: `thermometer__${f.value}`
    }, [
      e.value.style.title.text ? (o(), n("div", Me, [
        he(Ce, {
          config: {
            title: {
              cy: "thermometer-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "thermometer-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ])) : h("", !0),
      e.value.userOptions.show && P.value ? (o(), B(Fe, {
        ref: "details",
        key: `user_options_${N.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: v(T),
        isPrinting: v(S),
        uid: f.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: m.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: L.value,
        onToggleFullscreen: le,
        onGeneratePdf: v(G),
        onGenerateImage: v(V)
      }, ce({ _: 2 }, [
        s.$slots.optionPdf ? {
          name: "optionPdf",
          fn: q(() => [
            k(s.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        s.$slots.optionImg ? {
          name: "optionImg",
          fn: q(() => [
            k(s.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        s.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: q(({ toggleFullscreen: t, isFullscreen: u }) => [
            k(s.$slots, "optionFullscreen", j(A({ toggleFullscreen: t, isFullscreen: u })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : h("", !0),
      P.value ? (o(), n("svg", {
        key: 2,
        xmlns: v(xe),
        class: C({ "vue-data-ui-fullscreen--on": m.value, "vue-data-ui-fulscreen--off": !m.value }),
        width: "100%",
        viewBox: `0 0 ${l.value.width} ${l.value.height}`,
        style: z(`background:${e.value.style.chart.backgroundColor}`)
      }, [
        d("defs", null, [
          d("clipPath", Ue, [
            d("rect", {
              x: "0",
              y: "0",
              width: "1",
              height: "1",
              rx: "0.5",
              ry: "0.07",
              fill: e.value.style.chart.backgroundColor
            }, null, 8, qe)
          ]),
          (o(!0), n($, null, D(E.value, (t, u) => (o(), n("linearGradient", {
            id: `vueUiThermometerGradient_${u}_${f.value}`,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": t.color
            }, null, 8, Ne),
            d("stop", {
              offset: "50%",
              "stop-color": `${t.color}${v(be)[100 - e.value.style.chart.graduations.gradient.intensity]}`
            }, null, 8, Se),
            d("stop", {
              offset: "100%",
              "stop-color": t.color
            }, null, 8, Te)
          ], 8, Le))), 256))
        ]),
        d("g", Ge, [
          d("rect", {
            x: l.value.left,
            y: l.value.top,
            height: l.value.height - i.value.top - i.value.bottom,
            width: l.value.width - i.value.left - i.value.right,
            fill: "#FFFFFF"
          }, null, 8, Ve),
          (o(!0), n($, null, D(E.value, (t, u) => (o(), n("g", {
            key: `graduation_${u}`
          }, [
            d("rect", {
              x: t.x,
              y: t.y,
              height: t.height,
              width: l.value.width - e.value.style.chart.padding.left - e.value.style.chart.padding.right,
              fill: e.value.style.chart.graduations.gradient.show ? `url(#vueUiThermometerGradient_${u}_${f.value})` : t.color,
              "shape-rendering": "crispEdges"
            }, null, 8, We),
            e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
              key: 0,
              x1: t.x,
              x2: t.x + 10,
              y1: t.y,
              y2: t.y,
              "stroke-width": e.value.style.chart.graduations.strokeWidth,
              stroke: e.value.style.chart.graduations.stroke,
              "stroke-linecap": "round"
            }, null, 8, Ee)) : h("", !0),
            e.value.style.chart.graduations.showIntermediate ? (o(), n($, { key: 1 }, [
              e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
                key: 0,
                x1: t.x,
                x2: t.x + 5,
                y1: t.halfY,
                y2: t.halfY,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, ze)) : h("", !0),
              e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
                key: 1,
                x1: t.x,
                x2: t.x + 2.5,
                y1: t.qYLess,
                y2: t.qYLess,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, Be)) : h("", !0),
              e.value.style.chart.graduations.show && ["both", "left"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
                key: 2,
                x1: t.x,
                x2: t.x + 2.5,
                y1: t.qYMore,
                y2: t.qYMore,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, je)) : h("", !0)
            ], 64)) : h("", !0),
            e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
              key: 2,
              x1: l.value.right,
              x2: l.value.right - 10,
              y1: t.y,
              y2: t.y,
              "stroke-width": e.value.style.chart.graduations.strokeWidth,
              stroke: e.value.style.chart.graduations.stroke,
              "stroke-linecap": "round"
            }, null, 8, Ae)) : h("", !0),
            e.value.style.chart.graduations.showIntermediate ? (o(), n($, { key: 3 }, [
              e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
                key: 0,
                x1: l.value.right,
                x2: l.value.right - 5,
                y1: t.halfY,
                y2: t.halfY,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, De)) : h("", !0),
              e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
                key: 1,
                x1: l.value.right,
                x2: l.value.right - 2.5,
                y1: t.qYLess,
                y2: t.qYLess,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, He)) : h("", !0),
              e.value.style.chart.graduations.show && ["both", "right"].includes(e.value.style.chart.graduations.sides) ? (o(), n("line", {
                key: 2,
                x1: l.value.right,
                x2: l.value.right - 2.5,
                y1: t.qYMore,
                y2: t.qYMore,
                "stroke-width": e.value.style.chart.graduations.strokeWidth / 2,
                stroke: e.value.style.chart.graduations.stroke,
                "stroke-linecap": "round"
              }, null, 8, Xe)) : h("", !0)
            ], 64)) : h("", !0)
          ]))), 128)),
          d("rect", {
            class: C({ "vue-ui-thermometer-temperature": e.value.style.chart.animation.use }),
            x: l.value.left,
            y: l.value.top,
            height: M.value,
            width: l.value.width - e.value.style.chart.padding.left - e.value.style.chart.padding.right,
            fill: "#FFFFFF66"
          }, null, 10, Re)
        ]),
        d("text", {
          class: C({ "vue-ui-thermometer-temperature-value": e.value.style.chart.animation.use }),
          y: M.value + l.value.top + e.value.style.chart.label.fontSize / 3,
          x: l.value.left - 10,
          "text-anchor": "end",
          fill: e.value.style.chart.label.color,
          "font-size": e.value.style.chart.label.fontSize,
          "font-weight": e.value.style.chart.label.bold ? "bold" : "normal"
        }, de(v(_e)(
          e.value.style.chart.label.formatter,
          b.dataset.value,
          v(we)({
            p: e.value.style.chart.label.prefix,
            v: b.dataset.value,
            s: e.value.style.chart.label.suffix,
            r: e.value.style.chart.label.rounding
          }),
          { datapoint: b.dataset }
        )), 11, Je),
        k(s.$slots, "svg", { svg: Q.value }, void 0, !0)
      ], 14, Oe)) : h("", !0),
      s.$slots.watermark ? (o(), n("div", Ke, [
        k(s.$slots, "watermark", j(A({ isPrinting: v(S) || v(T) })), void 0, !0)
      ])) : h("", !0),
      P.value ? h("", !0) : (o(), B(Pe, {
        key: 4,
        config: {
          type: "thermometer",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            thermometer: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 14, Ye));
  }
}, rt = /* @__PURE__ */ Ie(Qe, [["__scopeId", "data-v-1375e978"]]);
export {
  rt as default
};
