import { computed as h, ref as p, watch as Z, onMounted as ee, openBlock as s, createElementBlock as v, normalizeClass as O, normalizeStyle as S, createVNode as te, createCommentVNode as _, createBlock as V, unref as d, createSlots as ae, withCtx as A, renderSlot as w, normalizeProps as X, guardReactiveProps as D, Fragment as M, renderList as H, toDisplayString as le } from "vue";
import { u as R } from "./useNestedProp-CN2WRozq.js";
import { u as re, c as oe, t as se, o as ne, e as ue, s as Y, X as ie, i as ce, f as ve } from "./index-DevyUpIh.js";
import { _ as he } from "./Title-Dq1rRDew.js";
import { u as de, U as ge } from "./usePrinter-BBCKkrZI.js";
import ye from "./vue-ui-skeleton-BcivVyJG.js";
import { _ as me } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const fe = ["id"], pe = ["xmlns", "viewBox"], ke = { key: 0 }, _e = ["d", "stroke-width", "stroke"], be = { key: 1 }, Ce = ["x1", "y1", "x2", "y2", "stroke-width", "stroke"], $e = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], xe = {
  key: 3,
  class: "vue-data-ui-watermark"
}, we = {
  __name: "vue-ui-tiremarks",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(q, { expose: J }) {
    const u = q, { vue_ui_tiremarks: K } = re(), F = h(() => !!u.dataset && Object.keys(u.dataset).length), z = p(oe()), N = p(null), G = p(0), e = h(() => {
      const t = R({
        userConfig: u.config,
        defaultConfig: K
      });
      return t.theme ? {
        ...R({
          userConfig: se.vue_ui_tiremarks[t.theme] || u.config,
          defaultConfig: t
        })
      } : t;
    }), { isPrinting: L, isImaging: U, generatePdf: j, generateImage: B } = de({
      elementId: z.value,
      fileName: e.value.style.chart.title.text || "vue-ui-tiremarks"
    }), i = p(e.value.style.chart.animation.use ? 0 : u.dataset.percentage);
    Z(() => u.dataset.percentage, () => {
      i.value = p(e.value.style.chart.animation.use ? 0 : u.dataset.percentage), E();
    }), ee(() => {
      ne(u.dataset) && ue({
        componentName: "VueUiTiremarks",
        type: "dataset"
      }), E();
    });
    function E() {
      let t = 0, n = e.value.style.chart.animation.speed, a = 5e-3 * e.value.style.chart.animation.acceleration;
      function r() {
        i.value += n + t, t += a, i.value < u.dataset.percentage ? requestAnimationFrame(r) : i.value = u.dataset.percentage;
      }
      e.value.style.chart.animation.use && (i.value = 0, r());
    }
    const k = h(() => e.value.style.chart.layout.display === "vertical"), o = h(() => {
      const t = {
        top: 48,
        left: 64,
        right: 64,
        bottom: 48
      };
      return k.value ? {
        top: e.value.style.chart.percentage.verticalPosition === "top" ? t.top : 3,
        left: 3,
        right: 3,
        bottom: e.value.style.chart.percentage.verticalPosition === "bottom" ? t.bottom : 3
      } : {
        top: 0,
        bottom: 0,
        left: e.value.style.chart.percentage.horizontalPosition === "left" ? t.left : 3,
        right: e.value.style.chart.percentage.horizontalPosition === "right" ? t.right : 10
      };
    }), P = h(() => Object.values(o.value).reduce((t, n) => t + n, 0)), l = h(() => ({
      height: k.value ? 312 : 56,
      width: k.value ? 56 : 312
    })), Q = p(100);
    h(() => u.dataset.percentage / Q.value);
    const c = h(() => k.value ? {
      mark: (l.value.height - P.value) / 100 * 0.5,
      space: (l.value.height - P.value) / 100 * 0.5
    } : {
      mark: (l.value.width - P.value) / 100 * 0.5,
      space: (l.value.width - P.value) / 100 * 0.5
    }), T = h(() => {
      const t = [];
      for (let a = 0; a < 100; a += 1) {
        const r = e.value.style.chart.layout.ticks.gradient.show ? Y(e.value.style.chart.layout.activeColor, a / 100 * (e.value.style.chart.layout.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.activeColor;
        if (k.value) {
          const C = e.value.style.chart.layout.crescendo ? (100 - a) * (l.value.width - o.value.left - o.value.right) / 100 / 3 : 0, g = o.value.left + 4 + C, y = l.value.width - o.value.right - 4 - C, m = l.value.height - o.value.bottom - a * c.value.mark - a * c.value.space - c.value.mark, f = l.value.height - o.value.bottom - a * c.value.mark - a * c.value.space - c.value.mark, $ = (y - g) / e.value.style.chart.layout.curveAngleX, x = e.value.style.chart.layout.curveAngleY * ((1 + a) / 100);
          t.push({
            x1: g,
            x2: y,
            y1: m,
            y2: f,
            curve: `M ${g} ${m} C ${g + $} ${m - x}, ${y - $} ${f - x}, ${y} ${f}`,
            color: r
          });
        } else {
          const C = e.value.style.chart.layout.crescendo ? (100 - a) * (l.value.height - o.value.top - o.value.bottom) / 100 / 3 : 0, g = o.value.left + a * c.value.mark + a * c.value.space - c.value.mark, y = g, m = o.value.top + 4 + C, f = l.value.height - o.value.bottom - 4 - C, $ = e.value.style.chart.layout.curveAngleY * ((1 + a) / 100), x = (f - m) / e.value.style.chart.layout.curveAngleX;
          t.push({
            x1: g,
            x2: y,
            y1: m,
            y2: f,
            curve: `M ${g} ${m} C ${g + $} ${m + x}, ${y + $} ${f - x}, ${y} ${f}`,
            color: r
          });
        }
      }
      return t;
    }), b = h(() => {
      let t, n, a;
      const r = e.value.style.chart.percentage.fontSize / 3;
      return k.value ? e.value.style.chart.percentage.verticalPosition === "top" ? (t = l.value.width / 2, n = o.value.top / 2, a = "middle") : e.value.style.chart.percentage.verticalPosition === "bottom" && (t = l.value.width / 2, n = l.value.height - o.value.bottom / 2 + r, a = "middle") : e.value.style.chart.percentage.horizontalPosition === "left" ? (t = 4, n = l.value.height / 2 + r, a = "start") : e.value.style.chart.percentage.horizontalPosition === "right" && (t = l.value.width - o.value.right + 8, n = l.value.height / 2 + r, a = "start"), {
        x: t,
        y: n,
        textAnchor: a,
        bold: e.value.style.chart.percentage.bold,
        fontSize: e.value.style.chart.percentage.fontSize,
        fill: e.value.style.chart.percentage.color
      };
    }), I = p(!1);
    function W(t) {
      I.value = t, G.value += 1;
    }
    return J({
      generatePdf: j,
      generateImage: B
    }), (t, n) => (s(), v("div", {
      ref_key: "tiremarksChart",
      ref: N,
      class: O(`vue-ui-tiremarks ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: S(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: z.value
    }, [
      e.value.style.chart.title.text ? (s(), v("div", {
        key: 0,
        style: S(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:12px`)
      }, [
        te(he, {
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : _("", !0),
      e.value.userOptions.show && F.value ? (s(), V(ge, {
        ref: "details",
        key: `user_options_${G.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: d(L),
        isImaging: d(U),
        uid: z.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: I.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: N.value,
        onToggleFullscreen: W,
        onGeneratePdf: d(j),
        onGenerateImage: d(B)
      }, ae({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: A(() => [
            w(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: A(() => [
            w(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: A(({ toggleFullscreen: a, isFullscreen: r }) => [
            w(t.$slots, "optionFullscreen", X(D({ toggleFullscreen: a, isFullscreen: r })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : _("", !0),
      F.value ? (s(), v("svg", {
        key: 2,
        xmlns: d(ie),
        class: O({ "vue-data-ui-fullscreen--on": I.value, "vue-data-ui-fulscreen--off": !I.value }),
        viewBox: `0 0 ${l.value.width} ${l.value.height}`,
        style: S(`max-width:100%; overflow: visible; background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        e.value.style.chart.layout.curved ? (s(), v("g", ke, [
          (s(!0), v(M, null, H(T.value, (a, r) => (s(), v("path", {
            d: a.curve,
            "stroke-width": c.value.mark,
            stroke: i.value >= r ? a.color : e.value.style.chart.layout.inactiveColor,
            "stroke-linecap": "round",
            fill: "none",
            class: O({ "vue-ui-tick-animated": e.value.style.chart.animation.use && r <= i.value })
          }, null, 10, _e))), 256))
        ])) : (s(), v("g", be, [
          (s(!0), v(M, null, H(T.value, (a, r) => (s(), v("line", {
            x1: a.x1,
            y1: a.y1,
            x2: a.x2,
            y2: a.y2,
            "stroke-width": c.value.mark,
            stroke: i.value >= r ? a.color : e.value.style.chart.layout.inactiveColor,
            "stroke-linecap": "round"
          }, null, 8, Ce))), 256))
        ])),
        e.value.style.chart.percentage.show ? (s(), v("text", {
          key: 2,
          x: b.value.x,
          y: b.value.y,
          "font-size": b.value.fontSize,
          fill: e.value.style.chart.layout.ticks.gradient.show && e.value.style.chart.percentage.useGradientColor ? d(Y)(e.value.style.chart.layout.activeColor, i.value / 100 * (e.value.style.chart.layout.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.percentage.color,
          "font-weight": b.value.bold ? "bold" : "normal",
          "text-anchor": b.value.textAnchor
        }, le(d(ce)(
          e.value.style.chart.percentage.formatter,
          i.value,
          d(ve)({
            v: i.value,
            s: "%",
            r: e.value.style.chart.percentage.rounding
          })
        )), 9, $e)) : _("", !0),
        w(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, pe)) : _("", !0),
      t.$slots.watermark ? (s(), v("div", xe, [
        w(t.$slots, "watermark", X(D({ isPrinting: d(L) || d(U) })), void 0, !0)
      ])) : _("", !0),
      F.value ? _("", !0) : (s(), V(ye, {
        key: 4,
        config: {
          type: "tiremarks",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            tiremarks: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 14, fe));
  }
}, Ne = /* @__PURE__ */ me(we, [["__scopeId", "data-v-0cc3937c"]]);
export {
  Ne as default
};
